nav_order = [];
nav_nearest = {};
search_bookmark = null;
use_popups = false;
popup_showing = null;

if('createTouch' in document /*&& window.innerWidth <= 1024*/) {
	setTimeout(initPopupStyle, 50);
} else {
	setTimeout(initAnchor, 50);
}

function initPopupStyle() {
	var heads = document.getElementsByTagName('head');
	var bodies = document.getElementsByTagName('body');
	if(! heads.length || ! bodies.length) {
		setTimeout(initPopupStyle, 50);
		return;
	}
	use_popups = true;
	bodies[0].className += ' no-sidebar';
	if(! checkPageAnchor()) {
		var main = $('main-frame');
		if(main)
			navToLink(main.src);
	}
}

function initAnchor() {
	var content = $('main-frame');
	if(! content) {
		setTimeout(initAnchor, 50);
		return;
	}
	checkPageAnchor();
}

if(! window.$) {
	function $(sel) {
		var t = typeof(sel);
		if(t == 'string')
			return document.getElementById(sel);
		else if(t == 'object' && sel.toElement)
			return sel.toElement();
		return sel;
	}
}

function showHide(elt, state, closeOthers) {
	display = state;
	elt = $(elt);
	if(! elt) return;
	if(typeof(display) == 'undefined')
		display = (elt.style.display == 'none')
	elt.style.display = display ? '' : 'none';
	var arrow_id = elt.id.replace('-sub', '-arrow')
	arrow = $(arrow_id);
	if(arrow) {
		if(display) arrow.className = arrow.className.replace('closed', 'open');
		else arrow.className = arrow.className.replace('open', 'closed');
	}
	if(closeOthers)
		toggleSiblings(elt, false);
	if(state) {
		var parent = elt.parentNode;
		while(parent && parent.tagName != 'UL')
			parent = parent.parentNode;
		if(parent)
			showHide(parent, state, closeOthers);
	}
}

function toggleSiblings(elt, state) {
	elt = $(elt);
	if(! elt) return;
	var elts = document.getElementsByTagName('UL');
	for(var i = 0; i < elts.length; i++) {
		if(elts[i].id != elt.id && elts[i].className == elt.className)
			showHide(elts[i], state);
	}
}

function toggleAll(state) {
	var elts = document.getElementsByTagName('UL');
	for(var i = 0; i < elts.length; i++) {
		if(elts[i].className != 'toc-0')
			showHide(elts[i], state);
	}
}

function setPageAnchor(anchor) {
	document.location.hash.replace('#' + anchor);
}

function checkPageAnchor() {
	var wwidth = (document.documentElement || document.body).clientWidth;
	if(wwidth > 1150)
		window.resizeBy(1150 - wwidth, 0);

	var hash = document.location.hash;
	if(hash) {
		var anchor = hash.substring(1);
		if( (m = anchor.match(/^search:(.*)$/)) ) {
			var query = decodeURI(m[1]);
			var queryInp = $('search-query');
			if(queryInp) queryInp.value = query;
			performSearch(query, true);
		}
		else
			followAnchor(anchor);
		return true;
	} else if(nav_order)
		updateNavButtons(nav_order[0]);
}

function clickTocLink(elt, idx, depth) {
	showHide('tocidx-'+idx+'-sub', true, true);
	var href = elt.href;
	if(! use_popups) {
		var p = href.indexOf('#');
		if(p >= 0) {
			var anchor = href.substring(p+1);
			setPageAnchor(anchor);
			updateNavButtons(anchor);
		}
	}
	if(! depth || use_popups) {
		if(! use_popups)
			href = href.replace(/#.*$/, '#top');
		navToLink(href);
		if(use_popups)
			closeSearch(); // also closes popup panel
		return false;
	}
}

function followAnchor(anchor, set_nav) {
	var alt_link = '';
	if(nav_nearest[anchor]) {
		alt_link = nav_nearest[anchor][0]+'#'+anchor;
		anchor = nav_nearest[anchor][1];
	}
	if(set_nav)
		setPageAnchor(anchor);
	var elts = document.getElementsByTagName('A');
	var match = '#'+anchor;
	for(var i = 0; i < elts.length; i++) {
		if(elts[i].className != 'tocitem')
			continue;
		var href = elts[i].href;
		if(href.substring(href.length - match.length) == match) {
			navToLink(alt_link || elts[i].href);
			var next = elts[i].parentNode.nextSibling;
			while(next && next.tagName != 'UL') {
				if(next.tagName == 'LI')
					next = null;
				else
					next = next.nextSibling;
			}
			showHide(next || elts[i].parentNode.parentNode, true, true);
			break;
		}
	}
	updateNavButtons(anchor);
	if(use_popups)
		hidePopupPanel();
}

function followSearch(anchor) {
	followAnchor(anchor, use_popups);
	search_bookmark = anchor;
	updateNavButtons(anchor);
	if(use_popups)
		hidePopupPanel();
}

function navToLink(href) {
	if(use_popups) {
		var anchor = '', p = href.indexOf('#');
		if(p >= 0) {
			anchor = href.substring(p);
			href = href.substring(0, p);
		}
		var c = $('content');
		c.innerHTML = '<p align="center" class="loading">Loading ..</p>';
		var xhr = getXHR();
		xhr.onreadystatechange = function() {
			if(xhr.readyState == 4) {
				if(xhr.status == 200) {
					loadContent(xhr.responseText);
					if(anchor) {
						setTimeout(function() { document.location.hash = anchor; }, 100);
					} else {
						setTimeout(function() { window.scrollTo(0, 1) },  100);
					}
				}
			}
		}
		xhr.open('GET', href, true);
		xhr.send(null);
		return false;
	}
	var main = $('main-frame');
	if(main) {
		main.src = href;
		main.focus();
	}
}

function loadContent(content) {
	var head = document.getElementsByTagName('head')[0];
	var style_css = $('style-css');
	if(! style_css) {
		style_css = document.createElement('link');
		style_css.type = 'text/css';
		style_css.rel = 'stylesheet';
		style_css.href = 'css/style.css';
		head.appendChild(style_css);
	}
	var page_css = $('page-css');
	var m = content.match(/<style type="text\/css">([\0\S\s]*?)<\/style>/);
	if(m) {
		if(! page_css) {
			page_css = document.createElement('style');
			page_css.id = 'page-css';
			page_css.type = 'text/css';
			head.appendChild(page_css);
		}
		page_css.nodeValue = m[1];
	} else if(page_css)
		page_css.innerText = '';
	var content = content.replace('<link rel="stylesheet" type="text/css" href="css/style.css" />', '');
	$('content').innerHTML = content;
}

function updateNavButtons(anchor) {
	var nav_next = $('nav-next');
	var nav_previous = $('nav-previous');
	if(nav_order.length && anchor)
		nav_next.style.display = nav_previous.style.display = '';
	else {
		nav_next.style.display = nav_previous.style.display = 'none';
		return;
	}
	var pos = nav_order.indexOf(anchor);
	var prev = '', next = '';
	if(pos < 0)
		anchor = nav_order[0];
	if(pos > 0)
		prev = nav_order[pos-1];
	if(pos >= 0 && pos < nav_order.length-1)
		next = nav_order[pos+1];
	if(nav_next) {
		nav_next.className = 'nav-link' + (next ? '' : ' disabled');
		nav_next.onclick = next ? function() { followAnchor(next, true); return false; } : function() { return false; };
	}
	if(nav_previous) {
		nav_previous.className = 'nav-link' + (prev ? '' : ' disabled');
		nav_previous.onclick = prev ? function() { followAnchor(prev, true); return false; } : function() { return false; };
	}
	var pdf_link = $('pdf-link');
	if(pdf_link) {
		pdf_link.onclick = function() {
			document.location.replace(pdf_link.href + '#nameddest=' + anchor);
			return false;
		}
	}
}

function getXHR() {
	if(window.XMLHttpRequest)
		return new XMLHttpRequest();
	else if(window.ActiveXObject) {
		try {
			return new ActiveXObject('Msxml2.XMLHTTP');
		} catch(e) {
			return new ActiveXObject('Microsoft.XMLHTTP');
		}
	}
}

function to_html(value, attrib) {
	if(! value) return value;
	value = value.replace(/</g,'&lt;').replace(/&/g, '&amp;');
	if(attrib) value = value.replace(/\"/g, '&quot;');
	return value;
}

function performSearch(query, nonav) {
	var panel = $('search-panel');
	if(! panel)
		return;
	panel.focus();
	if(! nonav)
		setPageAnchor('search:'+query);
	$('search-results').innerHTML = "Performing search..";
	panel.style.display = '';
	var xhr = getXHR();
	xhr.onreadystatechange = function() {
		if(xhr.readyState == 4) {
			if(xhr.status == 200) {
				var resultsDiv = $('search-results'); 
				try {
					eval('response = '+xhr.responseText);
				} catch(e) {
					resultsDiv.innerHTML = "Error parsing search results.";
					return;
				}
				if(response.count == 0) {
					resultsDiv.innerHTML = 'No results found.<br><br>';
					if(response.error)
						resultsDiv.innerHTML += response.error;
					return;
				}
				var html = '' + response.count + ' results found.<br><br>';
				nav_order = [];
				for(var i = 0; i < response.count; i++) {
					var result = response.results[i];
					var link = '<a class="tocitem search" href="'+result.file+'#'+result.bookmark+'" target="main" ' +
						'onclick="followSearch(\''+result.bookmark+'\'); return navToLink(this.href);">' + to_html(result.title) + '</a>';
					link = '<a class="arrow none">&nbsp;</a>' + link;
					html += '<div class="result-outer">' + link + '<p class="result-text">' + result.body + '</p></div>'
					nav_order.push(result.bookmark);
				}
				resultsDiv.innerHTML = html;
			} else {
				resultsDiv.innerHTML = "Error retrieving search results.";
			}
		}
	}
	xhr.open('GET', '../search.php?query='+encodeURIComponent(query), true);
	xhr.send(null);
	if(use_popups) {
		$('toc').style.display = 'none';
		showPopupPanel(panel);
	}
}

function closeSearch() {
	$('search-panel').style.display = 'none';
	$('search-results').innerHTML = '';
	$('search-query').value = '';
	if(search_bookmark) {
		setPageAnchor(search_bookmark);
		search_bookmark = null;
	}
	nav_order = [];
	updateNavButtons();
	if(use_popups)
		hidePopupPanel();
}

function showPdf() {
	document.location.replace('../index.php?format=pdf');
}

function showToc() {
	var toc = $('toc');
	if(! toc)
		return;
	var srch = $('search-panel');
	if(srch)
		srch.style.display = 'none';
	if(popup_showing === toc)
		hidePopupPanel();
	else
		showPopupPanel(toc);
}

function closeToc() {
	if(use_popups)
		hidePopupPanel();
}

function showPopupPanel(div) {
	var popup = $('popup-panel');
	if(! popup)
		return;
	popup.appendChild(div);
	div.style.display = 'block';
	popup.style.display = 'block';
	popup_showing = div;
	window.scrollTo(0, 1);
	setTimeout(function() { popup.focus(); }, 50);
}

function hidePopupPanel() {
	$('popup-panel').style.display = 'none';
	popup_showing = null;
}

function printContent() {
	var main = $('main-frame');
	if(main) {
		main.focus();
		(main.contentWindow || main).printPage();
	}
}

